/*
 * 反向代理解析
 *
 */

'use strict';
var _ = require( 'lodash' );
var get = require( 'get' );
/*
 var dictionary = [
 {
 location: '/ajax/dict',
 pass: 'http://setting-demo.ui.koolearn-inc.com/ajax/dict',
 type:'text/html; charset=utf-8'
 },
 {
 location: '/ajax/uploadcrossdomain',
 pass: '/ajax/uploadcrossdomain/index.php'
 }
 ];
 */
module.exports = function proxyMiddleware( dictionary ) {
    return function( req, res, next ) {
        var spathname = req._parsedUrl.pathname;
        var result = _.filter( dictionary, { location: spathname } );
        var url_pass, url_type, get_params;
        if( result.length ) {
            result = result[ 0 ];
            url_pass = result.pass;
            url_type = result.type || 'text/html; charset=utf-8';
            get_params = req._parsedUrl.query;
            if( url_pass.indexOf( 'http' ) === 0 ) {
                get( url_pass + '?' + get_params ).asBuffer( function( error, data ) {
                    if( error ) {
                        res.writeHead( 500, {
                            'Content-Type': url_type
                        } );
                        res.write( error );
                    } else {
                        res.writeHead( 200, {
                            'Content-Type': url_type
                        } );
                        res.write( data.toString() );
                    }
                    res.end();
                } );
            } else {
                req._parsedUrl.pathname = url_pass;
                next();
            }
        } else {
            next();
        }
    };
};